﻿using Infragistics.Win;
using Infragistics.Win.AppStyling;
using Infragistics.Win.AppStyling.Runtime;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraTreeRetrieveNodeStyles
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraTree1.Override.HotTracking = DefaultableBoolean.True;
            string output = "";

            /*Retrieve style library's style set*/

            ApplicationStyleLibrary styleLibrary = new ApplicationStyleLibrary();
            styleLibrary.LoadFromStyleManager();

            StyleSetSettings styleSet = null;
            if (styleLibrary.StyleSets.Count > 0 && styleLibrary.DefaultStyleSet != null)
                styleSet = styleLibrary.StyleSets[styleLibrary.DefaultStyleSet];

            if (styleSet == null)
            {
                styleSet = styleLibrary.StyleSets.Add("Default");
                styleLibrary.DefaultStyleSet = styleSet.Key;
            }

            /*Retrieve TreeNode role*/

            StyleSettings treeNodeRole = styleSet.RoleStyles.GetStyle("TreeNode", true);

            /*Retrieve Normal State of this role*/

            StateSettings normalState = (treeNodeRole.States.Exists(RoleState.Normal))
                ? treeNodeRole.States[RoleState.Normal]
                : treeNodeRole.States.Add(RoleState.Normal);

            AppearanceBase nodeAppearanceNormal = normalState.Appearance;

            output += "Node appearance (normal state) back color value:\n" + nodeAppearanceNormal.BackColor.Name;

            /*Retrieve Active State of this role*/

            StateSettings activeState = (treeNodeRole.States.Exists(RoleState.Active))
               ? treeNodeRole.States[RoleState.Active]
               : treeNodeRole.States.Add(RoleState.Active);

            AppearanceBase nodeAppearanceActive = activeState.Appearance;

            output += "\nNode appearance (active state) back color value:\n" + nodeAppearanceActive.BackColor.Name;

            /*Retrieve HotTracked State of this role*/

            StateSettings hotTrackedState = (treeNodeRole.States.Exists(RoleState.HotTracked))
              ? treeNodeRole.States[RoleState.HotTracked]
              : treeNodeRole.States.Add(RoleState.HotTracked);

            AppearanceBase nodeAppearanceHotTracked = hotTrackedState.Appearance;

            output += "\nNode appearance (hotTracked state) back color value:\n" + nodeAppearanceHotTracked.BackColor.Name;

            MessageBox.Show(output);

            /*Modify the active state color*/

            activeState.Appearance.BackColor = Color.AliceBlue;
            styleLibrary.UpdateStyleManager();
        }
    }
}
